<?php /*
Plugin Name: WP Recommended Posts
Plugin URI: http://javelinadevil.wordpress.com/?p=260
Description: Link to recommendation articls
Author: Javelina
Author URI: http://devilishdesign.net
Version: 0.0.1
Text Domain: wp-recommended-posts
Domain Path: /
*/
load_plugin_textdomain('wprp','wp-content/plugins/wp-recommended-posts');
add_action('admin_menu','wp_recommended_posts');
function wp_recommended_posts(){   
if (function_exists('add_submenu_page'))
add_submenu_page('edit.php', 'WP-Recomended-Posts', __('Recommended Posts','wprp'), '4', __FILE__, 'wprp_edit');
}
if($_GET['page'] == 'wp-recommended-posts/wp-recommended-posts.php'){
add_thickbox();
add_action('admin_head', 'wprp_head');
}
?>
<?php function wprp_head(){?>
<style type="text/css" media="screen">
table.wprp_table{
width:100%;
table-layout:fixed;
text-align:left;
border-collapse:collapse;
}
table.wprp_table thead th{
vertical-align:middle;
padding:3px 8px;
margin:0;
font-size:0.8em;
background:#eee;
}
table.wprp_table thead th.wprp_checkbox{
width:25px;
}
table.wprp_table thead th.wprp_title{
width:40%;
}
table.wprp_table thead th.wprp_category,
table.wprp_table thead th.wprp_tag,
table.wprp_table thead th.wprp_date{
width:15%;
}

table.wprp_table tbody th,
table.wprp_table tbody td{
vertical-align:top;
padding:8px;
margin:0;
border-bottom:1px dotted #aaa;
white-space: -moz-pre-wrap; /* Mozilla */
white-space: -pre-wrap;     /* Opera 4-6 */
white-space: -o-pre-wrap;   /* Opera 7 */
white-space: pre-wrap;      /* CSS3 */
word-wrap: break-word;      /* IE 5.5+ */
}
table.wprp_table tbody th{
color:#21759B;
font-size:0.9em;
}
table.wprp_table tbody td.wprp_checkbox{
text-align:center;
}
table.wprp_table tbody td.wprp_category,
table.wprp_table tbody td.wprp_tag,
table.wprp_table tbody td.wprp_date{
font-size:0.8em;
}
table.wprp_table tbody .bgcolor{
background:#eeFFfe;
}
div.now_wprp{
border:1px solid #ccc;
padding:5px 10px;
}
</style>
<script language="javascript">
function CheckSct(wprpID){
var npid = "np" + wprpID;
var pid = "p" + wprpID;
if(document.getElementById(npid).checked == true){
document.getElementById(pid).checked = true;
}else{
document.getElementById(pid).checked = false;
}
}
function CheckSct2(wprpID){
var npid = "np" + wprpID;
var pid = "p" + wprpID;
if(document.getElementById(pid).checked == true){
document.getElementById(npid).checked = true;
}else{
document.getElementById(npid).checked = false;
}
}
function ClearChecks(){  
var fnm = document.recommended_posts;
var len = fnm.elements.length
for (var i = 0; i < len; i++) {  
var checkbox = fnm.elements[i];  
checkbox.checked = false;
}  
} 
</script>
<?php }?>
<?php function wprp_edit(){?>
<?php $wprp_version = '0.0.1';?>
<div class="wrap">
<div id="icon-edit" class="icon32 icon32-posts-post"><br /></div> 
<h2><?php _e('Recommended Posts','wprp');?></h2>
<form name="recommended_posts" id="recommended_posts" method="post">
<?php
$wprp = $_POST['wprp'];
$wprp_submit = $_POST['wprp_submit'];

$haveposts = false;
$havepages = false;

if($wprp_submit == 1){
if($wprp){
$wprp = implode(',', array_unique($wprp));
}else{
$wprp = null;
}
update_option('wprp_id', $wprp);
}
unset($wprp);
$wprp = get_option('wprp_id');
$wprp_array = null;
$wprp_array = explode(',', $wprp);

?>
<?php if(!empty($wprp)){?>
<h3><?php _e('Registered recommendation articles','wprp');?></h3>
<div class="now_wprp">
<?php
foreach($wprp_array as $wprp_id){?>
<p>
<input type="checkbox" name="wprp[]" id="np<?php echo $wprp_id;?>" value="<?php echo $wprp_id;?>" OnClick="CheckSct(<?php echo $wprp_id;?>)" checked/>
<label for="np<?php echo $wprp_id;?>">
<?php echo get_the_title($wprp_id);?>
</label>
<a href="<?php echo get_permalink($wprp_id);?>?preview_iframe=1&amp;TB_iframe=true" class="button thickbox thickbox-preview" title="<?php echo __('Preview &#8220;','wprp') . get_the_title($wprp_id) . __('&#8221;','wprp');?>"><?php _e('Preview','wprp');?></a>
</p>
<?php }?>
</div>
<?php }?>
<p><input class="button-primary" type="submit" value="<?php _e('Save','wprp');?>" />
<input type="button" value=" <?php _e('Clear','wprp');?> " onclick="ClearChecks()"/></p>
<?php query_posts("post_type=post&posts_per_page=-1&post_status=publish");?>
<?php if (have_posts()) :?>
<h3><?php _e('Posts','wprp');?>:</h3>
<table class="wprp_table">
<thead>
<th class="wprp_checkbox"><!-- --></th>
<th class="wprp_title"><?php _e('Title','wprp');?></th>
<th class="wprp_category"><?php _e('Category','wprp');?></th>
<th class="wprp_tag"><?php _e('Tags','wprp');?></th>
<th class="wprp_date"><?php _e('Date','wprp');?></th>
<th class="wprp_preview"><?php _e('Preview','wprp');?></th>
</thead>
<tbody>
<?php while (have_posts()) : the_post(); ?>
<?php
$haveposts = true;
global $post;

$postcats = get_the_category();
if($postcats){
foreach($postcats as $cat){
$cats[] = $cat->cat_name;
}
$post_category = implode(',',$cats);
}

$posttags = get_the_tags();
if($posttags){
foreach($posttags as $tag){
$tags[] = $tag->name;
}
$post_tags = implode(',',$tags);
}
unset($posttags,$tag,$tags);
unset($postcats,$cat,$cats);
?>
<tr><td class="wprp_checkbox<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><input type="checkbox" name="wprp[]" id="p<?php echo $post->ID;?>" value="<?php echo $post->ID;?>" OnClick="CheckSct2(<?php echo $post->ID;?>)" <?php if(in_array($post->ID, $wprp_array)){echo 'checked';}?>/></td>
<th<?php if(in_array($post->ID, $wprp_array)){echo ' class="bgcolor"';}?>><label for="p<?php echo $post->ID;?>"><?php the_title();?></label></th>
<td class="wprp_category<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><?php echo $post_category;?></td>
<td class="wprp_tag<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><?php echo $post_tags;?></td>
<td class="wprp_date<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><?php the_time("Y/n/j g:i a");?></td>
<td<?php if(in_array($post->ID, $wprp_array)){echo ' class="bgcolor"';}?>><a href="<?php the_permalink();?>?preview_iframe=1&amp;TB_iframe=true" class="button thickbox thickbox-preview" title="<?php echo __('Preview &#8220;','wprp') . get_the_title() . __('&#8221;','wprp');?>"><?php _e('Preview','wprp');?></a></td>
</tr>
<?php endwhile;?>
</tbody>
</table>
<?php endif;?>
<?php if($haveposts || $havepages){?>
<p><input class="button-primary" type="submit" value="<?php _e('Save','wprp');?>" />
<input type="button" value=" <?php _e('Clear','wprp');?> " onclick="ClearChecks()"/></p>
<?php }?>
<?php wp_reset_query(); ?>
<p>&nbsp;</p>
<?php query_posts("post_type=page&posts_per_page=-1&post_status=publish");?>
<?php if (have_posts()) :?>
<h3><?php _e('Pages');?>:</h3>
<table class="wprp_table" cellspacing="0">
<thead>
<th class="wprp_checkbox"><!-- --></th>
<th class="wprp_title"><?php _e('Title','wprp');?></th>
<th class="wprp_category"><!-- --></th>
<th class="wprp_tag"><!-- --></th>
<th class="wprp_date"><?php _e('Date','wprp');?></th>
<th class="wprp_preview"><?php _e('Preview','wprp');?></th>
</thead>
<tbody>
<?php while (have_posts()) : the_post(); ?>
<?php
$havepages = true;
global $post;
?>
<tr><td class="wprp_checkbox<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><input type="checkbox" name="wprp[]" id="p<?php echo $post->ID;?>" value="<?php echo $post->ID;?>" OnClick="CheckSct2(<?php echo $post->ID;?>)" <?php if(in_array($post->ID, $wprp_array)){echo 'checked';}?>/></td>
<th<?php if(in_array($post->ID, $wprp_array)){echo ' class="bgcolor"';}?>><label for="p<?php echo $post->ID;?>"><?php the_title();?></label></th>
<td class="wprp_category<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><!-- --></td>
<td class="wprp_tag<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><!-- --></td>
<td class="wprp_date<?php if(in_array($post->ID, $wprp_array)){echo ' bgcolor';}?>"><?php the_time("Y/n/j g:i a");?></td>
<td<?php if(in_array($post->ID, $wprp_array)){echo ' class="bgcolor"';}?>><a href="<?php the_permalink();?>?preview_iframe=1&amp;TB_iframe=true" class="button thickbox thickbox-preview" title="<?php echo __('Preview &#8220;','wprp') . get_the_title() . __('&#8221;','wprp');?>"><?php _e('Preview','wprp');?></a></td>
</tr>
<?php endwhile;?>
</tbody>
</table>
<?php endif;?>
<?php if($haveposts || $havepages){?>
<p><input class="button-primary" type="submit" value="<?php _e('Save','wprp');?>" />
<input type="button" value=" <?php _e('Clear','wprp');?> " onclick="ClearChecks()"/></p>
<?php }?>
<input type="hidden" name="wprp_submit" value="1">
</form>
<p style="text-align:center"><small><?php echo 'WP Recommended Posts ' . $wprp_version;?></small></p>
</div>
<p>&nbsp;</p>
<?php }?>
<?php function recommended_posts($wprp_style = '',$wprp_link = ''){
$wprp = get_option('wprp_id');
$wprp_array = null;
$wprp_array = explode(',', $wprp);
if(empty($wprp_style)){
$wprp_style = 'li';
}
if(empty($wprp_link)){
$wprp_link = 'link';
}
switch ($wprp_style){
case 'li':
$wprp_style1 = '<li>';
$wprp_style2 = '</li>';
break;
case 'p':
$wprp_style1 = '<p>';
$wprp_style2 = '</p>';
break;
case 'dt':
$wprp_style1 = '<dt>';
$wprp_style2 = '</dt>';
break;
case 'dd':
$wprp_style1 = '<dd>';
$wprp_style2 = '</dd>';
break;
case 'div':
$wprp_style1 = '<div>';
$wprp_style2 = '</div>';
break;
case 'span':
$wprp_style1 = '<span>';
$wprp_style2 = '</span>';
break;
case 'strong':
$wprp_style1 = '<strong>';
$wprp_style2 = '</strong>';
break;
case 'em':
$wprp_style1 = '<em>';
$wprp_style2 = '</em>';
break;
case 'text':
$wprp_style1 = '';
$wprp_style2 = '';
break;
default:
$wprp_style1 = '<li>';
$wprp_style2 = '</li>';
break;
}
if(!empty($wprp)){
foreach($wprp_array as $wprp_id){
if($wprp_link == 'link'){
$wprp_ahref1 = '<a href="' . get_permalink($wprp_id) . '" title="' . get_the_title($wprp_id) . '">';
$wprp_ahref2 = '</a>';
}elseif($wprp_link == 'text'){
$wprp_ahref1 = '';
$wprp_ahref2 = '';
}else{
$wprp_ahref1 = '<a href="' . get_permalink($wprp_id) . '" title="' . get_the_title($wprp_id) . '">';
$wprp_ahref2 = '</a>';
}
echo $wprp_style1 . $wprp_ahref1 . get_the_title($wprp_id) . $wprp_ahref2 . $wprp_style2 . "\n";
}?>
<?php }}?>
<?php
$widget_ops = array('classname' => 'wprp', 'description' =>  __('Link to recommended posts(pages)','wprp'));
wp_register_sidebar_widget('wprp',__('Recommended Posts','wprp'),'wprp_widget',$widget_ops);
register_widget_control('wprp','wprp_control');

function wprp_widget($args){
$wprp_title = get_option('wprp_title');
if(empty($wprp_title)){
$title = __('Recommended Posts','wprp');
}else{
$title = $wprp_title;
}
$wprp_liststyle = get_option('wprp_liststyle');
if(empty($wprp_liststyle) || $wprp_liststyle == 'ul'){
$listbefore = '<ul>';
$listafter = '</ul>';
}elseif($wprp_liststyle == 'ol'){
$listbefore = '<ol>';
$listafter = '</ol>';
}else{
$listbefore = '<ul>';
$listafter = '</ul>';
}
$wprpid = get_option('wprp_id');
$wprp_array = null;
$wprp_array = explode(',', $wprpid);
extract($args);
if(!empty($wprpid)){
echo $before_widget . "\n";
echo $before_title . $title . $after_title . "\n";
echo $listbefore . "\n";
foreach($wprp_array as $wprp_id){
$wprp_ahref1 = '<li class="wprp_item wprp-item-'. $wprp_id . '"><a href="' . get_permalink($wprp_id) . '" title="' . get_the_title($wprp_id) . '">';
$wprp_ahref2 = '</a></li>';
echo $wprp_ahref1 . get_the_title($wprp_id) . $wprp_ahref2 . "\n";
}
echo $listafter . "\n";
echo $after_widget . "\n";
}
}
function wprp_control(){
$wprp_title = get_option('wprp_title');
$wprp_liststyle = get_option('wprp_liststyle');
if (isset($_POST['wprp_title_value'])) {
update_option('wprp_title', $_POST['wprp_title_value']);
}
if (isset($_POST['wprp_liststyle_value'])) {
update_option('wprp_liststyle', $_POST['wprp_liststyle_value']);
}
?>
<p><label for="wprp_title"><?php _e('Title','wprp');?>:<br />
<input type="text" class="widefat" id="wprp_title" name="wprp_title_value" value="<?php echo $wprp_title; ?>" /></label></p>
<p><?php _e('List-type','wprp');?>:<br />
<label for="wprp_ul"><input type="radio" id="wprp_ul" name="wprp_liststyle_value" value="ul" <?php if(empty($wprp_liststyle) || $wprp_liststyle == 'ul'){echo 'checked';}?>/> &#60;ul&#62;～&#60;/ul&#62;</label><br />
<label for="wprp_ol"><input type="radio" id="wprp_ol" name="wprp_liststyle_value" value="ol" <?php if($wprp_liststyle == 'ol'){echo 'checked';}?>/> &#60;ol&#62;～&#60;/ol&#62;</label>
</p>
<?php
}
?>